//yooooooooooooo
freeslot(
"S_KIRYU_PUNCH",
"S_KIRYU_PUNCH_MID",
"S_KIRYU_PUNCH_HEAT",
"S_KIRYU_PUNCH_END",
"S_KIRYU_FALLCHECK",
"S_KIRYU_DROPKICK",
"S_KIRYU_SLAMRISE",
"S_KIRYU_SLAMDOWN",
"S_KIRYU_SLAMLAND",
"S_KIRYU_SLAMGETUP",
"S_KIRYU_SLIDE",
"S_KIRYU_DIEFALL",
"S_KIRYU_OBJECTCOLLIDE",
"SPR_ATTK",
"SPR_ATK2",
"MT_KIRYU_DEAD",
"MT_KIRYU_HEATOVERLAY",
"S_KIRYU_FLAME",
"MT_KIRYU_LAUNCHEDOBJECT",
"MT_KIRYU_DEBRIS",
"SPR_KRFL",
"sfx_kybap1",
"sfx_kybap2",
"sfx_kybap3",
"sfx_kyhit1",
"sfx_kyhit2",
"sfx_kyhit3",
"sfx_kyslam",
"sfx_kykick",
"sfx_kyrise",
"sfx_kyspin",
"sfx_kypun1",
"sfx_kypun2",
"sfx_kyuppr"
)

sfxinfo[sfx_kybap1].caption = "/"
sfxinfo[sfx_kybap2].caption = "/"
sfxinfo[sfx_kybap3].caption = "/"
sfxinfo[sfx_kyhit1].caption = "/"
sfxinfo[sfx_kyhit2].caption = "/"
sfxinfo[sfx_kyhit3].caption = "/"
sfxinfo[sfx_kyslam].caption = "Earthquake"
sfxinfo[sfx_kykick].caption = "Whoosh"
sfxinfo[sfx_kyrise].caption = "Whish"
sfxinfo[sfx_kyspin].caption = "Spinning"
sfxinfo[sfx_kypun1].caption = "Whiff"
sfxinfo[sfx_kypun2].caption = "Whoof"
sfxinfo[sfx_kyuppr].caption = "Uppercut"

local enemyNames = {
"Takeuchi",
"Miyoshi",
"Eguchi",
"Kitano",
"Kawano",
"Matsuoka",
"Kagu",
"Furukawa",
"Sakata",
"Hiraoka",
"Hino",
"Fukushima",
"Kawai",
"Ootani",
"Nishio",
"Sakakibara",
"Shimada",
"Ide",
"Takamatsu",
"Inaba",
"Shimura",
"Kanazawa",
"Matsushita",
"Kawamoto",
"Suga",
"Sugawara",
"Yagi",
"Hosokawa",
"Ozawa",
"Ogura",
"Arakawa",
"Senda",
"Yoshioka",
"Aihara",
"Inagaki",
"Miyamoto",
"Matsuura",
"Tsutsui",
"Aoyanagai",
"Satake",
"Okuda",
"Nagano",
"Kobayashi",
"Kaneshiro",
"Adachi",
"Oohara",
"Fukui",
"Iijima",
"Tsuchida",
"Maruyama",
"Kawamura",
"Suda",
"Yoshino",
"Miki",
"Kishi",
"Kusano",
"Kawahara",
"Machida",
"Hatanaka",
"Ookubo",
"Oota",
"Miyata",
"Shimazaki",
"Nagai",
"Yamanaka",
"Shiota",
"Oouchi",
"Konishi",
"Matsui",
"Hara",
"Kano",
"Miyazawa",
"Kawabata",
"Kuroki",
"Horita",
"Takayama",
"Ishida",
"Hirano",
"Horikawa",
"Miyahara",
"Imai",
"Endo",
"Hashiguchi",
"Matuo",
"Fujioka",
"Nitta",
"Hattori",
"Kurihara",
"Nomura",
"Fukasawa",
"Ishihara",
"Yamaguchi",
"Ogawa",
"Yamagishi",
"Kawase",
"Ito",
"Yoshiwara",
"Matsuyama",
"Nakasawa",
"Iwase",
"Nishihara",
"Katayama",
"Imaizumi",
"Okuno",
"Tsuchii",
"Ohtsuki",
"Nishimoto",
"Umeda",
"Usui",
"Watabe",
"Miyagi",
"Motegi",
"Morimoto",
"Haraguchi",
"Matsunaga",
"Hayashida",
"Mishima",
"Honda",
"Ichikawa",
"Tanikawa",
"Tashiro",
"Sonoda",
"Mikami",
"Shimoda",
"Kojima",
"Enomoto",
"Yoshii",
"Iwamoto",
"Yamamura",
"Noguchi",
"Uemura",
"Koide",
"Itou",
"Mimura",
"Hirota",
"Watanabe",
"Komori",
"Tominaga",
"Shinohara",
"Yoshinaga",
"Matsuzaki",
"Ooi",
"Kitakawa",
"Takeda",
"Komatsu",
"Yokoyama",
"Nakada",
"Oonishi",
"Kiwami",
"Ikari"
}

//give every object a name upon spawning
local function GiveEnemyName(mo)
	//mo.kiryuname = enemyNames[P_RandomRange(1, table.maxn(enemyNames))]
	//seed the name based on position & leveltime, ensuring every map placed enemy has the same name every time
	//(because it's funny)
	mo.kiryuname = enemyNames[(abs(mo.x+mo.y+mo.z+leveltime) % table.maxn(enemyNames))+1]
end
addHook("MobjSpawn", GiveEnemyName)

//Different 1up icon for Kiryu
function A_Kiryu1upIcon(actor, var1, var2)
	if actor.skin == "kiryu"
		actor.frame = 1
	end
end
states[S_PLAY_BOX1].action = A_Kiryu1upIcon
states[S_PLAY_ICON1].action = A_Kiryu1upIcon
states[S_PLAY_ICON3].action = A_Kiryu1upIcon

local function KiryuSetup(player)
	if (player.mo) then
		player.mo.kiryuinfo = {
		kicktime = 0, // i don't remember what this does but its probably important
		//heat = 0,
		enemy = nil, //last enemy hit
		groundslam = false, //ground slamming
		enemieshit = {}, //enemies hit and to ignore
		enemyname = nil, //enemy name for dead enemies
		hudnametimer = 0, //timer until enemy name disappears
		enemytype = nil, //object type for last enemy hit, used for hud bar length after death
		heatdamage = gametyperules&GTR_CAMPAIGN and not modeattacking
		and not G_IsSpecialStage() and player.kiryuheatsave or 0, //amount of damage dealt recently
		heattime = 0, //countdown for heat mode draining
		heatactive = false, //heat mode engaged
		sing = 0,
		spin = 0,
		custom1 = 0,
		rings = player.rings,
		lastframe = {state = S_PLAY_STND, frame = A, tics = 0}, //used for restoring punches when landing mid-punch
		aircount = 0, //used to track count of punches in the air
		}
	end
end
addHook("PlayerSpawn", KiryuSetup)


//variables
local punchSpeed = 30*FRACUNIT
local SQUISHTIME = 8

//
// damage variables
//
local punchDamage = 6
local uppercutDamage = 13
local slamDamage = 13 //damage for when colliding with a enemy whilst slamming down, not the slam itself
local dropkickDamage = 8

//hud stuff
local deadEnemyLinger = TICRATE + (TICRATE/2) //how long should a dead enemy's name stay shown

//heat
local heatMax = 12000 //amount of heat needed to trigger heatmode
local heatFactor = 100 //percentage of heat gotten from damage
local heatDelay = 4*TICRATE //delay after dealing damage for heat to start lowering
local heatMaxDuration = 10*TICRATE //length that heat will last for

//how much damage needs to be dealt to damage a enemy
local defaultHealth = 10 //default hp when not set
local KiryuEnemyDamageValues = {}
KiryuEnemyDamageValues[MT_BLUECRAWLA] = 12
KiryuEnemyDamageValues[MT_REDCRAWLA] = 15
KiryuEnemyDamageValues[MT_ROBOHOOD] = 12
KiryuEnemyDamageValues[MT_FACESTABBER] = 24

//instant kills (flying enemies & explosives)
KiryuEnemyDamageValues[MT_GFZFISH] = 1
KiryuEnemyDamageValues[MT_GOLDBUZZ] = 1
KiryuEnemyDamageValues[MT_REDBUZZ] = 1
KiryuEnemyDamageValues[MT_JETJAW] = 1
KiryuEnemyDamageValues[MT_EGGGUARD] = 1
KiryuEnemyDamageValues[MT_PYREFLY] = 1
KiryuEnemyDamageValues[MT_SNAILER] = 1
KiryuEnemyDamageValues[MT_SPINCUSHION] = 1
KiryuEnemyDamageValues[MT_JETTGUNNER] = 1
KiryuEnemyDamageValues[MT_JETTBOMBER] = 1
KiryuEnemyDamageValues[MT_HANGSTER] = 1
KiryuEnemyDamageValues[MT_BUMBLEBORE] = 1
KiryuEnemyDamageValues[MT_BUGGLE] = 1
KiryuEnemyDamageValues[MT_TNTBARREL] = 1


local function DropKickTrigger(player)
	if not (player.mo.skin == "kiryu") then return end
	if (player.weapondelay) then return end
	
	player.mo.momz = -8*P_GetMobjGravity(player.mo)
	player.mo.z = $ + P_MobjFlip(player.mo)

	if not (P_IsObjectOnGround(player.mo)) then
		player.mo.kiryuinfo.enemieshit = {}
		S_StartSound(player.mo, P_RandomRange(sfx_krend3, sfx_krend4))
		S_StartSound(player.mo, sfx_kyspin)
		if player.mo.kiryuinfo.heatactive
			S_StartSound(player.mo, sfx_s3k7f)
		end
		if player.mo.eflags & MFE_UNDERWATER
			P_InstaThrust(player.mo, player.mo.angle, max(18*player.mo.scale, player.speed))
		else
			P_InstaThrust(player.mo, player.mo.angle, max(35*player.mo.scale, player.speed))
		end
		
		
		player.kickangle = player.mo.angle
		player.drawangle = player.mo.angle
		player.mo.state = S_PLAY_GLIDE
		player.panim = PA_DASH
		player.glidetime = 5*TICRATE
		player.mo.kiryuinfo.kicktime = TICRATE/2
		player.pflags = $|PF_THOKKED
	end
	return true
end
//addHook("JumpSpinSpecial", DropKickTrigger)

local function KiryuAirSafety(player)
	if not (P_IsObjectOnGround(player.mo)) then
		if (player.mo.state >= S_KIRYU_PUNCH)
		and (player.mo.state <= S_KIRYU_PUNCH_END) then
			player.mo.kiryuinfo.lastframe = {state = player.mo.state, frame = player.mo.frame, tics = player.mo.tics}
		else
			player.mo.kiryuinfo.airmelee = false
			return
		end
	
	else
		local inf = player.mo.kiryuinfo.lastframe
		player.mo.state = inf.state
		player.mo.frame = inf.frame
		player.mo.tics = inf.tics
		player.mo.kiryuinfo.airmelee = false
	end
end

local function CantPunch(player)
	if (srb2p)
	or (player.weapondelay)
	//or (player.mo.kiryuinfo.groundslam)
	or (P_PlayerInPain(player))
	or (player.pflags & PF_SLIDING)
	or (player.mo.state == S_PLAY_GASP)
	or (player.mo.state == S_KIRYU_SLAMLAND)
	or (player.mo.state == S_KIRYU_SLAMGETUP)
	or (player.powers[pw_carry])
	or (player.glidetime)
	or (player.exiting) then
		return true
	end
end

local function DragonPunch(player, targetmod)
	if not (player.mo.skin == "kiryu") then return end
	//if (player.pflags & PF_SPINDOWN) then return end

	if (CantPunch(player) or player.pflags & PF_SPINDOWN) then return end

	if not (targetmod) then
		targetmod = 1
	end

	player.pflags = $1 & ~PF_APPLYAUTOBRAKE &~ PF_SPINNING
	//player.pflags = $1 & ~PF_AUTOBRAKE
	
	//handle midair punching so you can't fly
	if not (P_IsObjectOnGround(player.mo)) then
		if (player.mo.kiryuinfo.aircount >= 3) then
			return
		end
		
		if not (player.pflags & PF_JUMPED)
			player.pflags = $ | P_GetJumpFlags(player)
		end
		
		player.mo.kiryuinfo.aircount = $1+1
	end
	
	local frame = D
	local delay = 10
	
	local didUpper = false
	
	if (player.mo.state >= S_KIRYU_PUNCH)
	and (player.mo.state <= S_KIRYU_PUNCH_END)
	or (player.mo.kiryuinfo.aircount > 1)
	
		if not (player.mo.frame <= C)
		or (player.mo.kiryuinfo.aircount == 2) then
			local punch2Noises = {sfx_kratk5, sfx_kratk8, sfx_kratk9}
			S_StartSound(player.mo, punch2Noises[P_RandomRange(1, #punch2Noises)])
			S_StartSound(player.mo, sfx_kypun2)
			if player.mo.kiryuinfo.heatactive
				S_StartSound(player.mo, sfx_s3k48)
			end
			frame = A
			delay = 15

		//dropkick
		else
			player.mo.kiryuinfo.airmelee = false
			player.weapondelay = 0
			DropKickTrigger(player)
			player.pflags = $1 & ~PF_STARTJUMP
			
			didUpper = true
			//return
		end
	
	//normal punch
	else
		local punch1Noises = {sfx_krjump, sfx_kratk2, sfx_kratk7}
		S_StartSound(player.mo, punch1Noises[P_RandomRange(1, #punch1Noises)])
		S_StartSound(player.mo, sfx_kypun1)
		if player.mo.kiryuinfo.heatactive
			S_StartSound(player.mo, sfx_s3k43)
		end
	end
	player.kiryusquish = -SQUISHTIME
	
	if (didUpper) then return end
	
	player.mo.kiryuinfo.enemieshit = {}
	player.drawangle = player.mo.angle
	
	//speed limit for punch bhopping
	if (player.speed < player.mo.scale*(20+(player.normalspeed/FRACUNIT)))
	or (player.mo.kiryuinfo.heatactive)
		P_Thrust(player.mo, player.mo.angle, 30*targetmod*player.mo.scale)
	end
	
	if (player.mo.momz < 0) then
		player.mo.momz = 0
	end
	
	player.mo.state = S_KIRYU_PUNCH
	player.mo.frame = frame
	//player.weapondelay = delay
	//player.pflags = $1|PF_JUMPSTASIS

	if not (P_IsObjectOnGround(player.mo)) then
		player.mo.kiryuinfo.airmelee = true
		KiryuAirSafety(player)
	end
	
	if (player.mo.kiryuinfo.heatactive) then
		player.mo.tics = 3
	end
end

addHook("SpinSpecial", DragonPunch)

mobjinfo[MT_KIRYU_DEBRIS] = {
	spawnstate = S_ROCKCRUMBLEB,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_BOUNCE|MF_GRENADEBOUNCE|MF_MISSILE
}

//heat overlay object
mobjinfo[MT_KIRYU_HEATOVERLAY] = {
	spawnstate = S_INVISIBLE,
	radius = 20*FRACUNIT,
	height = 30*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIP,
	dispoffset = 1
}

states[S_KIRYU_FLAME] = {SPR_KRFL, FF_ANIMATE, -1, nil, 2, 4, S_KIRYU_FLAME}

local function KiryuAddHeat(pmo, damage)
	local factor = heatFactor
	if All7Emeralds(emeralds) then factor = $*2 end
	
	pmo.kiryuinfo.heatdamage = min($1+(damage*factor), heatMax)
	
	if (pmo.kiryuinfo.heatactive) then return end
	pmo.kiryuinfo.heattime = heatDelay
end

local function HeatOverlay(player, hmo)

	if not (player.mo)
	or not (player.mo.valid) then return end
	if not (hmo) then return end
	
	hmo.flags2 = $ &~ MF2_LINKDRAW
	
	if not (player.mo.health)
		hmo.state = S_INVISIBLE
		return
	end

	hmo.scale = (player.mo.scale/100)*34
	hmo.spritexscale = player.mo.spritexscale
	hmo.spriteyscale = player.mo.spriteyscale
	hmo.spritexoffset = player.mo.spritexoffset
	hmo.spriteyoffset = player.mo.spriteyoffset
	hmo.rollangle = player.mo.rollangle

	if (player.mo.kiryuinfo.heatactive)
		if (All7Emeralds(emeralds)) then
			hmo.color = SKINCOLOR_CRIMSON
		else
			hmo.color = SKINCOLOR_COBALT
		end
		
		if not (hmo.state == S_KIRYU_FLAME) then
			hmo.state = S_KIRYU_FLAME
		end
		
		//hmo.frame = $1|TR_TRANS50
		hmo.blendmode = AST_ADD
	else
		hmo.state = S_INVISIBLE
	end
end
addHook("FollowMobj", HeatOverlay, MT_KIRYU_HEATOVERLAY)

local function KiryuGhost(pmo)
	local ghost = P_SpawnGhostMobj(pmo)
	ghost.spritexscale = pmo.spritexscale
	ghost.spriteyscale = pmo.spriteyscale
	if ghost.tracer then ghost.tracer.blendmode = AST_ADD end
	return ghost
end


//borrowing checks from P_LookForEnemies
//https://git.do.srb2.org/STJr/SRB2/-/blob/next/src/p_user.c#L9159
local function KiryuHeatSearch(pmo, mo)
	local player = pmo.player
	local dist
	local span = ANGLE_45

	if (mo.flags & MF_NOCLIPTHING)
		return
	end

	if (mo.health <= 0) // dead
		return
	end

	if not (mo.flags & MF_ENEMY)
	and not (mo.flags & MF_BOSS)
	or not (mo.flags & MF_SHOOTABLE)
	or (mo.flags & MF_SPRING)
	and not (mo.flags2 & MF2_INVERTAIMABLE) // allows if it has the flags desired XOR it has the invert aimable flag
		return
	end // not a valid target

	if (mo.flags2 & MF2_FRET)
		return
	end

	if (mo.flags & MF_MONITOR)
		return
	end

	if (mo.type == MT_DETON) // Don't be STUPID, Sonic!
		return
	end
	
	local zdist = (player.mo.z + player.mo.height/2) - (mo.z + mo.height/2)
	dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)

	if ((R_PointToAngle2(0, 0, dist, zdist) + span) > span*2)
		return
	end // Don't home outside of desired angle!

	dist = P_AproxDistance(dist, zdist)
	
	if ((twodlevel) or (player.mo.flags2 & MF2_TWOD))
	and (abs(player.mo.y-mo.y) > player.mo.radius)
		return
	end // not in your 2d plane

	if (mo.type == MT_PLAYER) // Don't chase after other players!
		return
	end

	if (pmo.kiryuinfo.temptarget)
	and (dist > pmo.kiryuinfo.tempdist)
		return
	end

	local an = R_PointToAngle2(pmo.x, pmo.y, mo.x, mo.y) - pmo.angle
	/*print(an/ANG1)
	if ((an < -ANGLE_45) or (an > ANGLE_45))
		print("NONE")
		return // behind back
	end*/


	if not (P_CheckSight(player.mo, mo))
		return
	end // out of sight

	pmo.kiryuinfo.temptarget = mo
	pmo.kiryuinfo.tempdist = dist
	return
end

local function KiryuHeatTarget(player)
	if player.cmd.buttons & BT_SPIN
		player.mo.kiryuinfo.spin = $ + 1
	elseif player.mo.kiryuinfo.spin
		player.mo.kiryuinfo.spin = 0
	end
	
	if (CantPunch(player)) then
		return
	end
	if (player.weapondelay) then return end
	if (player.mo.kiryuinfo.aircount >= 2) then return end

	local fireDelay = TICRATE/2

	//local lockon = P_LookForEnemies(player, false, true)
	local radius = 512*player.mo.scale
	searchBlockmap("objects", KiryuHeatSearch, player.mo, player.mo.x-radius, player.mo.x+radius, player.mo.y-radius, player.mo.y+radius)
	
	local lockon = player.mo.kiryuinfo.temptarget
	player.mo.kiryuinfo.temptarget = nil
	player.mo.kiryuinfo.tempdist = nil
	
	if (lockon)
	
		if (player == consoleplayer) // Only display it on your own view.
			local visual = P_SpawnMobj(lockon.x, lockon.y, lockon.z, MT_LOCKON) // positioning, flip handled in P_SceneryThinker
			
			if not (All7Emeralds(emeralds)) then
				visual.frame = C
			end
			
			if (player.weapondelay) then
				visual.colorized = true
				visual.color = SKINCOLOR_SILVER
			end
			
			visual.target = lockon
			visual.fuse = 1
		end
	end
	
	if (player.mo.kiryuinfo.spin > 5)
		
		if (lockon)
			player.mo.kiryuinfo.enemieshit = {}
			//face towards the target
			local newAngle = R_PointToAngle2(player.mo.x, player.mo.y, lockon.x, lockon.y)
			DragonPunch(player, 3)
			player.drawangle = newAngle
			player.mo.state = S_KIRYU_PUNCH_HEAT
			player.mo.frame = E
			player.mo.tracer = lockon
		else
			return
		end

		player.pflags = $1|PF_SPINDOWN
	end
end

local function KiryuHeatThinker(pmo)
	local player = pmo.player
	if not player then return end
	
	//Limit
	pmo.kiryuinfo.heatdamage = min($, heatMax)
	
	//Detect custom 1
	if player.cmd.buttons & BT_CUSTOM1
		pmo.kiryuinfo.custom1 = $ + 1
	elseif pmo.kiryuinfo.custom1
		pmo.kiryuinfo.custom1 = 0
	end
	
	//Get rings!
	if pmo.kiryuinfo.rings != player.rings
		if pmo.kiryuinfo.rings < player.rings
			pmo.kiryuinfo.rings = $ + 1
			KiryuAddHeat(pmo, 1)
		else
			pmo.kiryuinfo.rings = player.rings
		end
	end
	
	//Fire effect
	if (pmo.kiryuinfo.heatactive or pmo.kiryuinfo.heatdamage >= heatMax)
	and leveltime & 1
		local r = pmo.radius>>FRACBITS
		local x = pmo.x + (P_RandomRange(r, -r)<<FRACBITS)
		local y = pmo.y + (P_RandomRange(r, -r)<<FRACBITS)
		local z = pmo.z + (P_RandomKey((pmo.height*3/2)>>FRACBITS)<<FRACBITS)
		if P_MobjFlip(pmo) < 0 then z = $ - pmo.height/2 end
		local particle = P_SpawnMobjFromMobj(pmo, 0,0,0, MT_FLAMEPARTICLE)
		if not (pmo.kiryuinfo.heatactive)
			particle.color = player.skincolor
			particle.colorized = true
		elseif not All7Emeralds(emeralds)
			particle.color = SKINCOLOR_BLUE
			particle.colorized = true
		end
		particle.momx = pmo.momx/2
		particle.momy = pmo.momy/2
		particle.momz = pmo.momz/2
		particle.blendmode = AST_ADD
		P_TeleportMove(particle,x,y,z)
	end

	//Pressing custom 1
	if not (pmo.kiryuinfo.heatactive) and (pmo.kiryuinfo.custom1 == 1)
	and (pmo.kiryuinfo.heatdamage >= heatMax) then
		pmo.kiryuinfo.heatactive = true
		pmo.kiryuinfo.heattime = 0
		local heatNoises = {sfx_kraoa1, sfx_kraoa2, sfx_krsmon, sfx_krweak}
		S_StartSound(pmo, heatNoises[P_RandomRange(1, #heatNoises)])
		S_StartSoundAtVolume(pmo, sfx_becrsh, 128)
		for d = 0, 16
			P_SpawnParaloop(pmo.x, pmo.y, pmo.z + pmo.height,
			64*pmo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, false)
		end
	elseif (pmo.kiryuinfo.heatactive) and (pmo.kiryuinfo.custom1 == 1)
		pmo.kiryuinfo.heatdamage = 0
		pmo.kiryuinfo.heatactive = false
		local loseNoises = {sfx_krpet, sfx_krdodg, sfx_krwin1, sfx_krwin2}
		S_StartSound(pmo, loseNoises[P_RandomRange(1, #loseNoises)])
		S_StartSoundAtVolume(pmo, sfx_beeyow, 128)
		for d = 0, 16
			P_SpawnParaloop(pmo.x, pmo.y, pmo.z + pmo.height,
			64*pmo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, true)
		end
	end
	
	local drainVal = heatMax/heatMaxDuration
	
	//got all those chaos emeralds
	if (All7Emeralds(emeralds)) then
		drainVal = heatMax/(heatMaxDuration*2)
	end
	
	if (pmo.kiryuinfo.heatactive) then
		pmo.kiryuinfo.heattime = 0
	end
	
	//drain
	if (pmo.kiryuinfo.heattime) then
		pmo.kiryuinfo.heattime = $1-1
	elseif (pmo.kiryuinfo.heatactive)
		pmo.kiryuinfo.heatdamage = $1-drainVal
		
		if (pmo.kiryuinfo.heatdamage <= 0) then
			pmo.kiryuinfo.heatdamage = 0
			
			if (pmo.kiryuinfo.heatactive) then
				pmo.kiryuinfo.heatactive = false
				local loseNoises = {sfx_krpet, sfx_krdodg, sfx_krwin1, sfx_krwin2}
				S_StartSound(pmo, loseNoises[P_RandomRange(1, #loseNoises)])
				S_StartSoundAtVolume(pmo, sfx_beeyow, 128)
				for d = 0, 16
					P_SpawnParaloop(pmo.x, pmo.y, pmo.z + pmo.height,
					64*pmo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, true)
				end
			end
		end
	end
	
	//Save heat mode
	if not pmo.kiryuinfo.heatactive and pmo.kiryuinfo.heatdamage
		player.kiryuheatsave = pmo.kiryuinfo.heatdamage
	elseif player.kiryuheatsave != 0
		player.kiryuheatsave = 0
	end
end

local function KiryuSetDeadEnemy(pmo, target)
	pmo.kiryuinfo.enemyname = target.kiryuname
	pmo.kiryuinfo.hudnametimer = deadEnemyLinger
	pmo.kiryuinfo.enemytype = target.type
end

local function HeatPunchKnockback(pmo, target, deadenemy)
	if (pmo.kiryuinfo.heatactive) then
		//prevent the player from flying off
		if not (P_IsObjectOnGround(pmo)) then
			P_SetObjectMomZ(pmo, 5*FRACUNIT)
			P_InstaThrust(pmo, R_PointToAngle2(target.x, target.y, pmo.x, pmo.y), 6*pmo.scale)
		else
			P_InstaThrust(pmo, R_PointToAngle2(target.x, target.y, pmo.x, pmo.y), 12*pmo.scale)
		end
		P_SetObjectMomZ(pmo, 0)
		
		local quake = 8
		
		if not (deadenemy) then
			quake = 3
			P_InstaThrust(pmo, R_PointToAngle2(target.x, target.y, pmo.x, pmo.y), 14*pmo.scale)
		end
		
		if (consoleplayer)
		and (consoleplayer == pmo.player) then
			P_StartQuake(quake*pmo.scale, TICRATE/3)
		end
	end
end

local function DoKiryuDamage(target, inflictor, pmo, dmg, ignoreKnockback, vertMult)

	if not (vertMult) then
		vertMult = 1
	end

	//player, wham em
	if (target.type == MT_PLAYER) then
		P_DamageMobj(target, inflictor, pmo, 1)
		return
	end
	
	for _,val in ipairs(pmo.kiryuinfo.enemieshit) do
		if (target == val) then return end
	end

	//don't get hit twice
	//if (target.kiryulastdmg)
	//and (target.kiryulastdmg >= (leveltime-10)) then return end

	if not (target.kiryuhp) then
		target.kiryuhp = 0//mo.health*10
	end
	
	//heat impact
	if (pmo.state == S_KIRYU_PUNCH_HEAT) then
		pmo.state = S_KIRYU_PUNCH_END
		if (pmo.player)
		and (consoleplayer)
		and (consoleplayer == pmo.player) then
			P_StartQuake(18*pmo.scale, TICRATE/4)
		end
	end
	
	//enemy "HP"
	local damageVal = 10 
	if (KiryuEnemyDamageValues[target.type]) then
		damageVal = KiryuEnemyDamageValues[target.type]
	elseif (target.flags & MF_BOSS)
		damageVal = 1
	end
	
	//knock enemy back
	if not (target.flags & MF_BOSS)
	and not (target.flags & MF_MONITOR)
	and (target.flags & MF_ENEMY) then
		P_InstaThrust(target, R_PointToAngle2(pmo.x, pmo.y, target.x, target.y), pmo.scale*12*vertMult)
	end
	
	if (target.flags & MF_ENEMY)
		//stun the enemy
		if (target.tics >= 0) then
			target.tics = $1+10
		end
		S_StartSound(target, sfx_dmpain)
	end
	
	if target.flags & MF_MONITOR
		S_StartSound(target, sfx_kybap1+P_RandomRange(0, 2))
	else
		S_StartSound(target, sfx_kyhit1+P_RandomRange(0, 2))
	end
	
	//damage indicator
	local ghost = P_SpawnMobj(target.x, target.y, target.z, MT_OVERLAY)
	ghost.tics = 5
	ghost.target = target
	ghost.sprite = target.sprite
	ghost.frame = target.frame
	ghost.color = SKINCOLOR_WHITE
	ghost.colorized = true
	//
	
	target.kiryuhp = $1+dmg
	if (target.flags & (MF_ENEMY|MF_BOSS)) and not (target.flags & MF_MONITOR)
		pmo.kiryuinfo.enemy = target
		table.insert(pmo.kiryuinfo.enemieshit, target)
	end
	target.kiryulastdmg = leveltime
	
	if (target.flags & MF_MONITOR) then
		target.kiryuhp = damageVal
	end
	
	while (target.kiryuhp >= damageVal) do
	
	
		//launch enemy
		if (target.health == 1)
		and (target.flags & MF_ENEMY)
		and not (target.flags & MF_BOSS) then
			local launchMod = 1
			if (pmo.kiryuinfo.heatactive) then
				launchMod = 2
			end
			
			target.kiryuobj = {flags = target.flags, inf = inflictor, src = pmo, time = leveltime, type = target.type}
			target.type = MT_KIRYU_LAUNCHEDOBJECT
			local stateinfo = {sprite = target.sprite, sprite2 = target.sprite2, frame = target.frame}
			target.state = S_INVISIBLE
			target.sprite = stateinfo.sprite
			target.sprite2 = stateinfo.sprite2
			target.frame = stateinfo.frame
			target.flags = MF_MISSILE
			P_SetObjectMomZ(target, ((P_RandomRange(5, 9)*FRACUNIT)*launchMod)*vertMult)
			P_InstaThrust(target, R_PointToAngle2(pmo.x, pmo.y, target.x, target.y), (P_RandomRange(26, 40)*launchMod)*FRACUNIT)
			target.kiryuhp = 0
			target.health = 0
			KiryuAddHeat(pmo, dmg)
			KiryuSetDeadEnemy(pmo, target, true)
			HeatPunchKnockback(pmo, target)
			break
		end
		P_DamageMobj(target, inflictor, pmo, 1)
	
		target.kiryuhp = $1-damageVal

		if (target.health <= 0) then
			if (target.flags & (MF_ENEMY|MF_BOSS))
			and not (target.flags & MF_MONITOR) 
				KiryuSetDeadEnemy(pmo, target)
			end
			
			KiryuAddHeat(pmo, dmg)
			target.kiryuhp = 0
			P_RemoveMobj(ghost)
			break
		end
	end
	
	
	if not (target.flags & MF_MONITOR)
		if not (ignoreKnockback) then
			//bounce off enemy
			P_InstaThrust(pmo, R_PointToAngle2(target.x, target.y, pmo.x, pmo.y), 7*pmo.scale)
			HeatPunchKnockback(pmo, target)
			
			//cez boss
			//bounce off so you don't get crushed!
			if (target.type == MT_EGGMOBILE4) and inflictor.player then
				local fallbackSpeed = FixedMul(4*FRACUNIT, target.scale)
				local ang = R_PointToAngle2(target.x-target.momx, target.y - target.momy, inflictor.x - inflictor.momx, inflictor.y - inflictor.momy)
				P_InstaThrust(inflictor, ang, inflictor.player.speed+(fallbackSpeed))
				inflictor.momz = (8*inflictor.scale)*P_MobjFlip(inflictor)
			end
			
			pmo.player.powers[pw_nocontrol] = 5
			
			//end the punching animation early
			if (pmo.state == S_KIRYU_PUNCH)
			or (pmo.state == S_KIRYU_PUNCH_HEAT)
			or (pmo.state == S_KIRYU_PUNCH_MID) then
				pmo.state = S_KIRYU_PUNCH_END
				pmo.tics = 12
			end
		end

		KiryuAddHeat(pmo, dmg)
	end
	
	//target the player if you've got no target
	if (pmo)
	and not (target.target)
		target.target = pmo
	end

end

//brief enemy invincibility
//no same frame hits
local function KiryuEnemyFrame(pmo, mo)
	if not (mo.flags & MF_ENEMY) then return end
	
	if (mo.kiryulastdmg)
	and (mo.kiryulastdmg == leveltime)
		return false
	end
end
addHook("MobjCollide", KiryuEnemyFrame, MT_PLAYER)
addHook("MobjMoveCollide", KiryuEnemyFrame, MT_PLAYER)




local function PunchSpring(mo, spring)
	if not (spring.flags & MF_SPRING or spring.type == MT_EGGSHIELD
	or spring.type == MT_SPIKE or spring.type == MT_WALLSPIKE) then return end
	if not (mo.player) then return end
	if not (mo.skin == "kiryu") then return end
	if not (mo.z - mo.scale + mo.momz <= spring.z + spring.height + spring.momz
	and mo.z + mo.height + mo.scale + mo.momz >= spring.z + spring.momz) then return end
	
	//spring boost
	local attacking = false
	if ((mo.state >= S_KIRYU_PUNCH)
	and (mo.state <= S_KIRYU_SLAMDOWN))
	or mo.state == S_PLAY_TWINSPIN
	or mo.state == S_PLAY_FLY
	or mo.state == S_PLAY_GLIDE then
		attacking = true
	end
	
	if (attacking) then
		if spring.flags & MF_SPRING
			mo.player.charability2 = CA2_MELEE
			mo.player.panim = PA_ABILITY2
		else
			P_KillMobj(spring, mo, mo)
			KiryuAddHeat(mo, 1)
			if spring.type == MT_EGGSHIELD
				A_Scream(spring)
				
				P_InstaThrust(mo, R_PointToAngle2(spring.x, spring.y, mo.x, mo.y), 7*mo.scale)
				HeatPunchKnockback(mo, spring)
				
				mo.player.powers[pw_nocontrol] = 5
			
				//end the punching animation early
				if (mo.state == S_KIRYU_PUNCH)
				or (mo.state == S_KIRYU_PUNCH_HEAT)
				or (mo.state == S_KIRYU_PUNCH_MID) then
					mo.state = S_KIRYU_PUNCH_END
					mo.tics = 12
				end
			end
		end
	end
end
addHook("MobjMoveCollide", PunchSpring, MT_PLAYER)

local function KiryuIgnoreDamage(pmo, inflictor, source, damage, damagetype)
	if pmo.kiryuinfo.heatactive
	and (damagetype == DMG_FIRE or (inflictor and inflictor.flags & MF_FIRE))
		return false
	elseif (inflictor) then
		if (inflictor.kiryulastdmg)
		and (inflictor.kiryulastdmg >= (leveltime-10)) then return false end
	end
end
addHook("ShouldDamage", KiryuIgnoreDamage, MT_PLAYER)


local function KiryuPunchFallCheck(mo)
	if (P_IsObjectOnGround(mo)) then
		mo.state = S_PLAY_RUN
	end
end

//states[S_KIRYU_PUNCH] = {SPR_PLAY, SPR2_CLMB, 6, A_KiryuMelee, 1, 4, S_KIRYU_PUNCH_END}
//states[S_KIRYU_PUNCH_END] = {SPR_PLAY, SPR2_CLMB, 14, nil, 0, 0, S_PLAY_STND}
states[S_KIRYU_PUNCH] = {SPR_PLAY, SPR2_CLMB, 3, nil, 0, 0, S_KIRYU_PUNCH_MID}
states[S_KIRYU_PUNCH_MID] = {SPR_PLAY, SPR2_CLMB, 10, nil, 2, 2, S_KIRYU_PUNCH_END}
states[S_KIRYU_PUNCH_END] = {SPR_PLAY, SPR2_CLMB, 8, nil, 0, 0, S_KIRYU_FALLCHECK}
states[S_KIRYU_FALLCHECK] = {SPR_PLAY, SPR2_CLMB, 0, KiryuPunchFallCheck, 0, 0, S_PLAY_FALL}
states[S_KIRYU_PUNCH_HEAT] = {SPR_PLAY, SPR2_CLMB, TICRATE/2, nil, 2, 2, S_KIRYU_PUNCH_END}

states[S_KIRYU_DROPKICK] = {SPR_PLAY, SPR2_MLEE, 2, nil, 0, 0, S_KIRYU_DROPKICK}
states[S_KIRYU_SLIDE] = {SPR_PLAY, SPR2_MLEL, -1, nil, 0, 0, S_PLAY_STND}

states[S_KIRYU_SLAMRISE] = {SPR_PLAY, SPR2_BNCE, 20, nil, 0, 0, S_KIRYU_SLAMDOWN}
states[S_KIRYU_SLAMDOWN] = {SPR_PLAY, SPR2_BNCE, -1, A_ZThrust, -40, 0, S_PLAY_STND}
states[S_KIRYU_SLAMLAND] = {SPR_PLAY, SPR2_LAND, 12, nil, 0, 0, S_KIRYU_SLAMGETUP}
states[S_KIRYU_SLAMGETUP] = {SPR_PLAY, SPR2_MLEL, 5, nil, 0, 0, S_PLAY_STND}

states[S_KIRYU_DIEFALL] = {SPR_PLAY, SPR2_PAIN, -1, nil, 0, 0, S_PLAY_DEAD}


mobjinfo[MT_KIRYU_LAUNCHEDOBJECT] = {
	deathstate = S_KIRYU_OBJECTCOLLIDE,
	flags = MF_MISSILE|MF_NOCLIPTHING
}

local function LaunchedObjectTrail(mo)
	if not (leveltime % 3) then
		local smokey = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
		smokey.scale = mo.scale
	end
end

addHook("MobjThinker", LaunchedObjectTrail, MT_KIRYU_LAUNCHEDOBJECT)

function A_KiryuLaunchedObject(mo)
	if not (mo.kiryuobj) then return end

	mo.type = mo.kiryuobj.type
	mo.flags = mo.kiryuobj.flags
	mo.state = mobjinfo[mo.kiryuobj.type].deathstate
	P_KillMobj(mo, mo.kiryuobj.inf, mo.kiryuobj.src)
end
states[S_KIRYU_OBJECTCOLLIDE] = {SPR_NULL, 0, -1, A_KiryuLaunchedObject, 0, 0, S_NULL}


function A_KiryuSetFrame(mo)
	mo.frame = D
end


//
// DROPKICK
//

local function DropKick(player)
	
	if not (player.mo.state == S_KIRYU_SLIDE)
	and not (player.mo.state == S_KIRYU_DROPKICK)
	and not (player.mo.state == S_PLAY_GLIDE)
	and not (player.mo.state == S_PLAY_TWINSPIN) then
		player.mo.kiryuinfo.kicktime = 0
		return
	end
	
	if (player.mo.state == S_KIRYU_DROPKICK)
	and ((player.mo.frame & FF_FRAMEMASK) == C) then
		player.mo.tics = -1
	end
	
	player.drawangle = player.kickangle
	player.panim = PA_DASH
	
	//sliding on the ground
	if (P_IsObjectOnGround(player.mo))
		if not (leveltime % 3) then
			P_SpawnSkidDust(player, player.mo.radius, true)
		end
		
		player.skidtime = 0
		player.mo.state = S_KIRYU_SLIDE
		player.mo.kiryuinfo.kicktime = $1-1
		
		if not (player.mo.kiryuinfo.kicktime) then
			player.mo.state = S_PLAY_STND
		end
		
	elseif (player.mo.state == S_KIRYU_SLIDE) //slid off somewhere
		player.mo.state = S_PLAY_FALL
		player.mo.kiryuinfo.kicktime = 0
		
	elseif player.mo.state != S_PLAY_TWINSPIN
		player.mo.momz = $ - P_GetMobjGravity(player.mo)/2
	end
end


//
// GROUND SLAM
//

local function GroundSlamTrigger(player)
	if not (player.mo.skin == "kiryu")
	or player.charability != CA_DOUBLEJUMP then return end
	if (player.weapondelay)
	or (player.pflags & PF_THOKKED and player.secondjump >= 3)
	then return true end
	
	if (player.pflags & PF_THOKKED)
		player.secondjump = $ + 1
	else
		player.secondjump = 1
		player.pflags = $1|PF_THOKKED
	end
	
	//Upper
	if player.secondjump == 1
		local upperNoises = {sfx_krjump, sfx_kratk2, sfx_kratk7, sfx_kratk5, sfx_kratk8, sfx_kratk9}
		S_StartSound(player.mo, upperNoises[P_RandomRange(1, #upperNoises)])
		S_StartSound(player.mo, sfx_kyuppr)
		if player.mo.kiryuinfo.heatactive
			S_StartSound(player.mo, sfx_s3k48)
		end
		player.mo.state = S_PLAY_FLY
		player.pflags = $&~PF_JUMPED
		P_DoJump(player, false)
		player.mo.momz = $*5/4
		
	//Kick
	elseif player.secondjump == 2
		local kickNoises = {sfx_krend2, sfx_krend5}
		S_StartSound(player.mo, kickNoises[P_RandomRange(1, #kickNoises)])
		S_StartSound(player.mo, sfx_kykick)
		if player.mo.kiryuinfo.heatactive
			S_StartSound(player.mo, sfx_s3k43)
		end
		
		player.mo.state = S_PLAY_TWINSPIN
		player.panim = PA_DASH
		
		if player.mo.momz*P_MobjFlip(player.mo) > 0 then player.mo.momz = 0 end
		player.mo.momz = $ + 16*P_GetMobjGravity(player.mo)
		
		if player.mo.kiryuinfo.heatactive
		and player.speed < 60*player.mo.scale
		and not (player.mo.eflags & MFE_UNDERWATER)
			P_Thrust(player.mo, player.mo.angle, 32*player.mo.scale)
		elseif player.speed < 40*player.mo.scale
		and (player.mo.kiryuinfo.heatactive or not (player.mo.eflags & MFE_UNDERWATER))
			P_Thrust(player.mo, player.mo.angle, 16*player.mo.scale)
		elseif player.speed < 20*player.mo.scale
			P_Thrust(player.mo, player.mo.angle, 8*player.mo.scale)
		end
		
		player.kickangle = player.mo.angle
		player.drawangle = player.mo.angle
		player.mo.kiryuinfo.kicktime = TICRATE/2
		
	//Slam
	elseif player.secondjump == 3
		player.mo.kiryuinfo.enemieshit = {}
		local slamNoises = {sfx_krend6, sfx_krend7, sfx_krend9}
		S_StartSound(player.mo, slamNoises[P_RandomRange(1, #slamNoises)])
		S_StartSound(player.mo, sfx_kyrise)
		if player.mo.kiryuinfo.heatactive
			S_StartSound(player.mo, sfx_s3k7f)
		end
		player.mo.state = S_KIRYU_SLAMRISE
		player.mo.momz = -32*P_GetMobjGravity(player.mo)
		player.mo.kiryuinfo.groundslam = true
		
		if FixedHypot(player.cmd.forwardmove, player.cmd.sidemove) < 35
		or P_GetPlayerControlDirection(player) == 2
			player.mo.momx = $/8
			player.mo.momy = $/8
		end
	end
	
	player.kiryusquish = SQUISHTIME
	if player.mo.kiryuinfo.heatactive
		player.mo.momz = $*3/2
	end
	
	return true
end
addHook("AbilitySpecial", GroundSlamTrigger)


local function BustableDetect(player)
	local rover
	
	if (player.mo.momz > 0) then
		rover = player.mo.ceilingrover
	else
		rover = player.mo.floorrover
	end
	
	if not (rover)
	or not (rover.flags & FF_EXISTS)
	or not (rover.flags & FF_BUSTUP) then
		return
	end
	
	if (P_MobjFlip(player.mo)*(player.mo.z+player.mo.height) > (rover.bottomheight+1))
	and (P_MobjFlip(player.mo)*(player.mo.z+player.mo.momz) < (rover.topheight+1))
		EV_CrumbleChain(rover)
		if rover.master.flags & ML_EFFECT5
			P_LinedefExecute(P_AproxDistance(rover.master.dx, rover.master.dy)>>FRACBITS, mo, rover.target)
		end
		return true
	end
end

local function GroundSlamDamage(pmo, mo)
	if not (mo.flags & MF_SHOOTABLE and mo.flags & MF_ENEMY) then return end
	
	if not (P_IsObjectOnGround(mo)) then return end
	
	//height limit
	if (mo.z < pmo.z - (128*pmo.scale))
	or (mo.z > pmo.z + (128*pmo.scale)) then
		return
	end
	
	DoKiryuDamage(mo, pmo, pmo, punchDamage, true, 3)
end


local function GroundSlamAttack(inflictor, radius)
	local source = inflictor
	local ns = radius
	local fa
	local mo
	local i
	local grounded = P_IsObjectOnGround(inflictor)


	for i = 1, 16
		//fa = (i*(8192/16)) //FINEANGLES 8192 ANGLE_MAX
		fa = FixedAngle(((FRACUNIT*360)/16)*i)
		local x = inflictor.x + FixedMul(sin(fa),ns)
		local y = inflictor.y + FixedMul(cos(fa),ns)
		local z = inflictor.z
		mo = P_SpawnMobj(x, y, z, MT_KIRYU_DEBRIS)
		if (mo.valid)
			mo.fuse = TICRATE+(TICRATE/2)
			mo.scale = P_RandomRange(6, 8)*(inflictor.scale/10)
			P_SetObjectMomZ(mo, P_RandomRange(8, 10)*FRACUNIT)
		end
	end
	
	local mo = inflictor
	
	searchBlockmap("objects", GroundSlamDamage, mo, mo.x - radius, mo.x + radius, mo.y - radius, mo.y + radius)
end

local function GroundSlam(player)

	if (P_IsObjectOnGround(player.mo)) then
		//slam sound should go here too
		S_StartSound(player.mo, sfx_kyslam)
		player.mo.kiryuinfo.groundslam = false
		GroundSlamAttack(player.mo, 256*player.mo.scale)
		
		//screen shake
		//only for the kiryu player
		if (consoleplayer)
		and (consoleplayer == player) then
			P_StartQuake(18*player.mo.scale, TICRATE/3)
		end
		
		player.mo.momx = $/4
		player.mo.momy = $/4
		player.mo.state = S_KIRYU_SLAMLAND
	else
	
		if (player.mo.state >= S_KIRYU_SLAMRISE)
		and (player.mo.state <= S_KIRYU_SLAMGETUP) then
		else
			player.mo.kiryuinfo.groundslam = false
			return
		end

		//afterimage for slamming
		if (player.mo.state == S_KIRYU_SLAMDOWN) then
			player.mo.momz = $ + P_GetMobjGravity(player.mo)
			if not (leveltime % 2) then
				KiryuGhost(player.mo)
			end
		end

		//disable jumping to prevent flying kiryus
		player.pflags = $1|PF_JUMPSTASIS
		BustableDetect(player)
		
	end
end


//
// DEATH
//

local function KiryuDead(player)

	if player.kiryuheatsave != 0
		player.kiryuheatsave = 0
	end

	if not (player.mo.skin == "kiryu")
		if (player.mo.type == MT_KIRYU_DEAD)
			player.mo.state = S_INVISIBLE
		end
		return
	end

	if (player.mo.state == S_KIRYU_DIEFALL)
	and (P_IsObjectOnGround(player.mo)) then
		player.mo.state = S_PLAY_DEAD
	end

end


local function PunchHoming(player)
	if not (player.mo.tracer)
	or (player.mo.tracer.flags2 & MF2_FRET) then
		P_ResetPlayer(player)
		player.mo.tracer = nil
		return
	end

	KiryuGhost(player.mo)
	
	local oldspd = player.actionspd
	local oldability = player.charability
	player.charability = CA_HOMINGTHOK
	
	local oldangle = player.cmd.angleturn<<FRACBITS
	player.actionspd = 256*player.mo.scale
	P_HomingAttack(player.mo, player.mo.tracer)
	player.mo.angle = oldangle
	
	if player == displayplayer and camera
		camera.momx = $/4
		camera.momy = $/4
		camera.momz = $/4
	end

	player.actionspd = oldspd
	player.charability = oldability
end

local function MeleeThink(player)

	if (player.mo.state >= S_KIRYU_PUNCH)
	and (player.mo.state <= S_KIRYU_PUNCH_END)
		player.pflags = $1 & ~PF_APPLYAUTOBRAKE
		player.pflags = $1 & ~PF_AUTOBRAKE
		player.powers[pw_justsprung] = max($, 2) //prevent turning
		
		if (player.mo.state == S_KIRYU_PUNCH_HEAT) then
			PunchHoming(player)
		end
	end
end

//
// MASTER THINKER
//

local function KiryuInputs()
	for player in players.iterate do
		if not (player.mo) then continue end
		
		//player.mo.kiryuinfo.enemieshit = {}
		
		if not (player.mo.skin == "kiryu") then continue end
		
		if (player.powers[pw_nocontrol])
		and (player.powers[pw_nocontrol] <= 6)
		and (player.cmd.buttons & BT_SPIN)
		and not (player.pflags & PF_SPINDOWN) then
			player.mo.kiryuinfo.meleebuffer = true
		end
		
		if not (player.powers[pw_nocontrol])
		and (player.mo.kiryuinfo.meleebuffer) then
			player.pflags = $1 & ~PF_SPINDOWN
			player.cmd.buttons = $1 & BT_SPIN
			player.mo.kiryuinfo.meleebuffer = false
		end
		
		if (player.mo.kiryuinfo.heatactive) then
			HeatOverlay(player)
			KiryuHeatTarget(player)
		end
		
		if (player.mo.state >= S_KIRYU_PUNCH)
		and (player.mo.state <= S_KIRYU_PUNCH_END) then
			player.panim = PA_ABILITY2
		end
		
		if player.mo.kiryuinfo.kicktime and P_IsObjectOnGround(player.mo)
			player.cmd.forwardmove = 0
			player.cmd.sidemove = 0
			player.cmd.angleturn = player.realmo.angle>>FRACBITS
			player.powers[pw_noautobrake] = max($, 2)
		end
		
		MeleeThink(player)
		
		//reset spring hacks
		if (player.charability2 == CA2_MELEE) then
			player.charability2 = CA2_NONE
		end
	end
end
addHook("PreThinkFrame", KiryuInputs)


local function KiryuEnemyHudThinker(player)
	if (player.mo.kiryuinfo.hudnametimer) then
		player.mo.kiryuinfo.hudnametimer = $1-1
	end
	
	if (player.mo.kiryuinfo.enemy)
	and (player.mo.kiryuinfo.enemy.valid)
	and not (player.mo.kiryuinfo.enemy.flags & MF_BOSS) then
		//if far away enough and targeted enemy isn't a boss
		//hide hp bar and clear timer (in case enemy was somehow killed within last second and leaving)
		if (R_PointToDist2(player.mo.x, player.mo.y, player.mo.kiryuinfo.enemy.x, player.mo.kiryuinfo.enemy.y) > 4096*FRACUNIT) then
			player.mo.kiryuinfo.enemy = nil
			player.mo.kiryuinfo.hudnametimer = 0
		end
	end
end

local function PunchThrust(player)
	
	if (player.mo.state == S_KIRYU_PUNCH_END)
		return
	end
	
	if (P_MobjFlip(player.mo)*player.mo.momz < 0) then
		player.mo.momz = 0
	end
	
	//punch afterimage
	if not (leveltime % 5) then
		local ghost = KiryuGhost(player.mo)
		ghost.frame = player.mo.frame|TR_TRANS60
	end
	
	local speedBonus = 16*player.mo.scale
	if player.mo.kiryuinfo.heatactive
		speedBonus = $*2
	end
	
	if (player.mo.state == S_KIRYU_PUNCH_MID)
	and (player.mo.tics < states[player.mo.state].tics-2)
		if (player.mo.tics) then
			local speedMult = max((100 * player.mo.tics) / (states[player.mo.state].tics/2), 100)
			
			speedBonus = ($1 * speedMult) / 100
		else
			speedBonus = 0
		end
	end
	
	if not (player.mo.state == S_KIRYU_PUNCH_MID)
	and not (player.mo.tics <= states[player.mo.state].tics/2)
		player.pflags = $1|PF_JUMPSTASIS
	end
	local speed = (player.normalspeed/FRACUNIT)*player.mo.scale
	if player.mo.eflags & MFE_UNDERWATER
		speed = $/2
		speedBonus = $/2
	end
	
	//lowest tics goes is 1
	P_InstaThrust(player.mo, player.drawangle, speed+speedBonus)
end

local function PlayerThinker()
	for player in players.iterate do
	
		if not (player.mo) then continue end
		
		if player.powers[pw_carry] == CR_NIGHTSMODE
		and player.mo.skin == "kiryu"
			if not player.mo.kiryunights
				player.mo.eflags = $ | MFE_FORCESUPER
				player.mo.kiryunights = true
				player.mo.state = $
				S_StartSound(player.mo, P_RandomRange(sfx_maent1, sfx_maent3))
				
			elseif player.exiting and player.mo.state == S_PLAY_NIGHTS_TRANS1
			and player.mo.tics == states[S_PLAY_NIGHTS_TRANS1].tics - 1
				S_StartSound(player.mo, P_RandomRange(sfx_mawin1, sfx_mawin3))
			end
			
			if S_SoundPlaying(player.mo, sfx_nghurt)
				S_StopSoundByID(player.mo, sfx_nghurt)
				S_StartSound(player.mo, P_RandomRange(sfx_maow1, sfx_maow3))
			end
			
			if player.mo.state == S_PLAY_NIGHTS_PULL
				if not player.mo.kiryunightspull
					player.mo.kiryunightspull = true
					S_StartSound(player.mo, sfx_maslow)
				end
			elseif player.mo.kiryunightspull
				player.mo.kiryunightspull = false
			end
		elseif player.mo.kiryunights
			player.mo.eflags = $ &~ MFE_FORCESUPER
			player.mo.kiryunights = false
			player.mo.state = $
			if player.mo.skin == "kiryu"
				if player.powers[pw_carry] == CR_NIGHTSFALL
					S_StartSound(player.mo, P_RandomRange(sfx_malos1, sfx_malos3))
				end
				for d = 0, 16
					P_SpawnParaloop(player.mo.x, player.mo.y, player.mo.z + player.mo.height,
					64*player.mo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, true)
				end
			end
		end
		
		//Squish code
		if player.kiryusquish
			if player.kiryusquish > 0
				player.kiryusquish = $ - 1
			else
				player.kiryusquish = $ + 1
			end
			local factor = 8
			if abs(player.kiryusquish) <= SQUISHTIME/3 then factor = $*4
			elseif abs(player.kiryusquish) <= SQUISHTIME*2/3 then factor = $*2 end
			player.mo.spritexscale = FRACUNIT - sin(player.kiryusquish*ANGLE_45)/factor
			player.mo.spriteyscale = FRACUNIT + sin(player.kiryusquish*ANGLE_45)/factor
		end
		
		if player.mo.skin == "kiryu" and not P_IsObjectOnGround(player.mo)
			local momz = min(player.mo.momz*P_MobjFlip(player.mo), 0)
			local factor = UINT8_MAX
			if player.mo.state == S_KIRYU_SLAMDOWN
				factor = INT8_MAX
			end
			if player.kiryusquish
				player.mo.spritexscale = $ + FixedDiv(momz/factor, player.mo.scale)
				player.mo.spriteyscale = $ - FixedDiv(momz/factor, player.mo.scale)
			else
				player.mo.spritexscale = FRACUNIT + FixedDiv(momz/factor, player.mo.scale)
				player.mo.spriteyscale = FRACUNIT - FixedDiv(momz/factor, player.mo.scale)
				player.kiryusquish = nil
			end
		elseif player.kiryusquish == nil
			player.kiryusquish = 0
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
		end
		//No squish code
		
		if not (player.mo.health) then
			KiryuDead(player)
			continue
		end
		
		if not (player.mo.skin == "kiryu") then continue end
		
		//SRB2P ability
		if srb2p and player.charability == CA_NONE
			player.charability = CA_DOUBLEJUMP
		end
		
		//Jumping squish
		if player.mo.state == S_PLAY_JUMP and player.pflags & PF_STARTJUMP
		and player.pflags & PF_JUMPED and player.pflags & PF_NOJUMPDAMAGE
		and not (player.pflags & (PF_THOKKED|PF_SHIELDABILITY))
		and player.mo.momz*P_MobjFlip(player.mo) >= 0
			player.kiryusquish = -SQUISHTIME/2
			if mariomode
				player.mo.state = S_PLAY_FLY_TIRED
			else
				player.mo.state = S_PLAY_SPRING
			end
			player.panim = PA_JUMP
			player.mo.tics = -1
		end
		
		//Landing squish
		if not (P_IsObjectOnGround(player.mo)
		or player.mo.eflags & MFE_JUSTHITFLOOR)
			player.kiryulanding = $ and $ + 1 or 1
		elseif player.kiryulanding
			if player.kiryulanding >= 5
				player.kiryusquish = -SQUISHTIME/2
			end
			player.kiryulanding = 0
		end
		
		//Punch wall breaking
		if ((player.mo.state >= S_KIRYU_PUNCH)
		and (player.mo.state <= S_KIRYU_PUNCH_END))
		or player.mo.state == S_PLAY_TWINSPIN
		or player.mo.state == S_PLAY_GLIDE then
			player.charflags = $|SF_CANBUSTWALLS
			player.kiryubust = true
		elseif player.kiryubust
			player.charflags = $ &~ SF_CANBUSTWALLS
		end
		
		//Enemy HUD
		KiryuEnemyHudThinker(player)
		if not G_IsSpecialStage() and not srb2p
			KiryuHeatThinker(player.mo)
		end
		
		//reset air punch count
		if (P_IsObjectOnGround(player.mo)) then
			player.mo.kiryuinfo.aircount = 0
		end
		
		//check to see if punch state should be restored because you landed
		if (player.mo.kiryuinfo.airmelee) then
			KiryuAirSafety(player)
		end
		
		if (player.mo.state == S_KIRYU_SLAMLAND)
		or (player.mo.state == S_KIRYU_SLAMGETUP)
			continue
		end
		
		if (player.mo.state == S_PLAY_FLY)
			if player.mo.momz*P_MobjFlip(player.mo) <= 0
				player.mo.state = S_PLAY_FALL
			elseif not (leveltime % 5) then
				KiryuGhost(player.mo)
			end
		end
		
		if (player.mo.kiryuinfo.kicktime) then
			DropKick(player)
		end
		
		if (player.mo.state >= S_KIRYU_PUNCH)
		and (player.mo.state <= S_KIRYU_PUNCH_END)
		and not (player.mo.state == S_KIRYU_PUNCH_HEAT)
			PunchThrust(player)
		end
		
		if (player.mo.kiryuinfo.groundslam)
			GroundSlam(player)
		end
		
	end

end

addHook("ThinkFrame", PlayerThinker)



//
// OTHER
//

local function KirmeDeath(mo, inflictor, source, damagetype)
	if not (mo.skin == "kiryu") then return end

	if not (damagetype)
	or not (damagetype == DMG_DROWNED)
		P_PlayDeathSound(mo)
	else
		S_StartSound(mo, sfx_drown)
	end

	if (inflictor) then
		local fallbackspeed = FixedMul(4*FRACUNIT, inflictor.scale)
		local ang = R_PointToAngle2(inflictor.x-inflictor.momx, inflictor.y - inflictor.momy, mo.x - mo.momx, mo.y - mo.momy)
		
		if (mo.player)
			mo.player.drawangle = ang + ANGLE_180
		end
		P_SetObjectMomZ(mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
		P_InstaThrust(mo, ang, fallbackspeed)
	else
		if (P_IsObjectOnGround(mo)) then
			P_SetObjectMomZ(mo, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
		end
	end
	
	mo.state = S_KIRYU_DIEFALL

	//change our object type so we don't bounce like players
	mo.type = MT_KIRYU_DEAD
	if (mo.player) then
		mo.player.lives = $1-1
	end
	
	//fall down pits
	if (damagetype == DMG_DEATHPIT)
		mo.state = S_INVISIBLE
		mo.momx,mo.momy,mo.momz = 0,0,0
		mo.flags = MF_NOCLIP
		return true
	end

	return true
end
addHook("MobjDeath", KirmeDeath, MT_PLAYER)


local function KirmeDamageCheck(player, mo)
	if not (player.mo.skin == "kiryu") then return end
	

	local dropKick
	//hasn't landed
	if ((player.mo.kiryuinfo.kicktime)
	and (player.mo.kiryuinfo.kicktime == TICRATE/2))
	or player.mo.state == S_PLAY_GLIDE
		dropKick = true
	end
	
	//only for special cases
	if not (player.mo.state == S_KIRYU_SLAMDOWN)
	and not (player.mo.state == S_KIRYU_PUNCH)
	and not (player.mo.state == S_KIRYU_PUNCH_MID)
	and not (player.mo.state == S_KIRYU_PUNCH_HEAT)
	and not (player.mo.state == S_KIRYU_PUNCH_END)
	and not (player.mo.state == S_PLAY_FLY)
	and not (player.mo.state == S_PLAY_TWINSPIN)
	and not (player.mo.state == S_KIRYU_SLIDE and player.mo.kiryuinfo.kicktime >= TICRATE/4)
	and not (dropKick) then
		return
	end
	
	//slamming down, don't bounce back up
	local doBounce = true
	if (player.mo.state == S_KIRYU_SLAMDOWN)
	or (player.mo.state == S_PLAY_TWINSPIN)
	or (player.mo.state == S_KIRYU_SLIDE) then
		doBounce = false
	end
	
	if not (mo.flags & MF_SHOOTABLE) then
		return true
	end

	if (player.mo.state >= S_KIRYU_PUNCH)
	and (player.mo.state <= S_KIRYU_PUNCH_END) then
	//monitors behave weird
		if (mo.flags & MF_MONITOR) then
			if (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) > -(2*player.mo.scale))
			and (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) < mo.height+(2*player.mo.scale))
			else
				return
			end
		end
		
		if (player.mo.state == S_KIRYU_PUNCH_HEAT) then
			player.homing = 0
			player.mo.tracer = nil
		end
		
		DoKiryuDamage(mo, player.mo, player.mo, punchDamage)
		return
	end
	
	//monitors behave weird
	if (mo.flags & MF_MONITOR) then
		if (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) > -(2*player.mo.scale))
		and (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) < mo.height+(2*player.mo.scale))
			P_KillMobj(mo, player.mo, player.mo)
		else
			return
		end
		
	elseif (mo.flags & (MF_ENEMY|MF_BOSS))
		player.mo.kiryuinfo.enemy = mo
	end
	
	if not (doBounce) then
		//Damage the enemy this way instead so we don't bounce
		DoKiryuDamage(mo, player.mo, player.mo, slamDamage)
		
		//Single frame invincibility
		//So you don't get hurt whilst the enemy is still "alive"
		if not (player.powers[pw_flashing]) then
			player.powers[pw_flashing] = 1
		end
		
		return
	else
	
		//do damage before knockback so enemy is kicked away instead of pulled with you
		DoKiryuDamage(mo, player.mo, player.mo, dropkickDamage)
	
		player.weapondelay = 5
		player.mo.kiryuinfo.kicktime = 0
		player.glidetime = 0
		player.secondjump = 0
		player.mo.kiryuinfo.aircount = 0
		player.mo.state = S_PLAY_SPINDASH
		player.pflags = $1 | PF_JUMPED & ~PF_NOJUMPDAMAGE & ~PF_THOKKED

		local fallbackSpeed = FixedMul(4*FRACUNIT, mo.scale)
		local ang = R_PointToAngle2(mo.x-mo.momx, mo.y - mo.momy, player.mo.x - player.mo.momx, player.mo.y - player.mo.momy)

		P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
		
		return
	end
	
	return false
end

addHook("PlayerCanDamage", KirmeDamageCheck)

local function SpawnWallDebris(mo, fallbackSpeed, num)
	//spawn debris
	for i = 1, num do
		local objtype = MT_KIRYU_DEBRIS
		local debris = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.height/2), objtype)
		debris.fuse = 2*TICRATE
		
		if not (debris)
		or not (debris.valid) then continue end
		
		debris.scale = mo.scale/2
		
		//add a small amount of randomization
		local modifier = FixedAngle((FRACUNIT/10)*P_RandomRange(-20, 20))
		P_InstaThrust(debris, mo.player.drawangle+modifier+(ANGLE_45*i)-(ANGLE_180+ANGLE_90), fallbackSpeed)
	end
end

local function KiryuLineCollide(mo, thing, line)
	if not (mo.skin == "kiryu" and mo.player)
	or not line or (line.backsector
	and line.backsector.ceilingpic == "F_SKY1"
	and line.frontsector
	and line.frontsector.ceilingpic == "F_SKY1"
	and (mo.z >= line.frontsector.ceilingheight
	or mo.z >= line.backsector.ceilingheight))
	or line.special == 41 then
		return
	end
	
	local punch
	
	if not (mo.state == S_PLAY_TWINSPIN) then
		if (mo.state == S_KIRYU_PUNCH)
		or (mo.state == S_KIRYU_PUNCH_MID)
		or (mo.state == S_KIRYU_PUNCH_END)
			punch = true
		else
			return
		end
	end
	
	//going through a destructable
	if (dontStop) then
		return true
	end

	local bounceX, bounceY = P_ClosestPointOnLine(mo.x, mo.y, line)
	local fallbackSpeed = FixedMul(4*FRACUNIT, mo.scale)
	local multi = 14
	
	mo.player.pflags = $ &~ PF_JUMPED
	P_DoJump(mo.player,false)
	mo.player.pflags = $ &~ PF_STARTJUMP
	
	//local ang = R_PointToAngle2(mo.x-mo.momx, mo.y - mo.momy, player.mo.x - player.mo.momx, player.mo.y - player.mo.momy)
	if (punch) 
		mo.momz = $/2
		
		if (hasSlope) then
			return
		end
		
		local oldSprite = mo.sprite2
		local oldFrame = mo.frame
		
		//use end of swing punching frames only
		if (mo.frame == A) then
			oldFrame = B
		elseif (mo.frame == C) then
			oldFrame = D
		end
		
		mo.state = S_PLAY_MELEE_FINISH
		mo.tics = 8
		SpawnWallDebris(mo, fallbackSpeed, 2)
		
		mo.sprite2 = oldSprite
		mo.frame = oldFrame
		
		multi = 10
	else
		mo.state = S_PLAY_JUMP
		SpawnWallDebris(mo, fallbackSpeed, 3)
		if (mo.kiryuinfo) then
			mo.kiryuinfo.kicktime = 0
		end
	end
		
	//screen shake
	//only for the kiryu player
	if (consoleplayer)
	and (consoleplayer == mo.player) then
		P_StartQuake(multi*mo.scale, TICRATE/5)
	end
	
	P_InstaThrust(mo, mo.player.drawangle-ANGLE_180, fallbackSpeed*2)
	S_StartSoundAtVolume(mo, sfx_doorc2, 200)
end

addHook("MobjMoveBlocked", KiryuLineCollide, MT_PLAYER)

//Ducking
local function KiryuDuck(player)
	if player.mo and player.mo.valid and player.mo.skin == "kiryu"
	and (player.mo.state == S_KIRYU_SLIDE or player.mo.state == S_KIRYU_SLAMLAND)
		return P_GetPlayerSpinHeight(player)
	end
end
addHook("PlayerHeight", KiryuDuck)
addHook("PlayerCanEnterSpinGaps", KiryuDuck)

//Don't bother with the HUD in SRB2 Persona
if srb2p then return end

//funny health bars for the enemies
local function KiryuEnemyHP(v, player)

	if not (player.mo.kiryuinfo.enemy) then return end
	
	
	local enemyObj = player.mo.kiryuinfo.enemy
	
	
	local bonusHP = 0
	
	local enemy = {}
	
	if not (enemyObj.valid)
	or not (enemyObj.health) then
	
		if not (player.mo.kiryuinfo.enemyname)
		or not (player.mo.kiryuinfo.enemytype)
		or not (player.mo.kiryuinfo.hudnametimer) then
			return
		end
	
		enemy.kiryuname = player.mo.kiryuinfo.enemyname
		enemy.type = player.mo.kiryuinfo.enemytype
		enemy.health = 0
	
	else
		enemy = enemyObj
		
		if (enemy.kiryuhp) then
			bonusHP = enemy.kiryuhp
		end
	end
	
	local enemyName = enemy.kiryuname
	
	if (yakuzaBossTexts[enemy.type]) then
		enemyName = yakuzaBossTexts[enemy.type].name
		enemyName = "\130"..string.gsub(enemyName, "\n", " ")
	end

	//enemy "HP"
	local damageVal = 10 
	if (KiryuEnemyDamageValues[enemy.type]) then
		damageVal = KiryuEnemyDamageValues[enemy.type]
	elseif (enemy.flags and enemy.flags & MF_BOSS)
		damageVal = 1
	end
	
	//convert to percent
	local healthPercent = (100*((enemy.health * damageVal) - bonusHP)) / (max(mobjinfo[enemy.type].spawnhealth,1)*damageVal)

	if (healthPercent > 100) then
		healthPercent = 100
	end

	local healthPos = 320-10
	local healthHeight = 190

	local BARC1 = 24	//health interior
	local BARC2 = 54	//health bar
	local BARC3 = 30	//health outline
	//scale hp bar length based on hp
	local maxBar = 50
	
	maxBar = damageVal*max(mobjinfo[enemy.type].spawnhealth,1)
	
	if (maxBar < 50) then
		maxBar = 50
	end
	
	if (maxBar > 180) then
		maxBar = 180
	end
	//
	
	local barLength = (maxBar * healthPercent) / 100
	
	if (enemyName) then
		v.drawString(healthPos-v.stringWidth(enemyName), healthHeight-10, enemyName, V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER)
	end
	
	v.drawFill(healthPos-maxBar-3, healthHeight-1, maxBar+6, 7, BARC3|V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER)
	v.drawFill(healthPos-maxBar, healthHeight, maxBar, 5, BARC1|V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER)
	
	if (healthPercent) then
		//thanks golden, tatsuru and flame for pointing out how this could be done!
		v.drawFill(healthPos-maxBar+(maxBar-barLength), healthHeight, barLength, 5, BARC2|V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER)
	end
	//ENERGY BAR END
	
end

local function HeatHUD(v, player)
	local maxBar = 80
	
	//black bg
	v.drawFill(16-3-2, 176-maxBar-3, 5+4, maxBar+6, 30|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
	
	//background
	v.drawFill(16-3, 176-maxBar, 5, maxBar, 24|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
	
	if (player.mo)
	and (player.mo.kiryuinfo.heatdamage) then
		local heatPercent = (player.mo.kiryuinfo.heatdamage)
		if (heatPercent > heatMax) then
			heatPercent = heatMax
		end
		
		local color = 150
		if (All7Emeralds(emeralds)) then
			color = 35
		end
		
		local healthPercent = (100*(heatPercent) / heatMax)
		local barLength = (maxBar * healthPercent) / 100
		v.drawFill(16-3, 176-maxBar+(maxBar-barLength), 5, barLength, color|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
		
		if (heatPercent >= heatMax)
		or (player.mo and player.mo.kiryuinfo.heatactive) then
			v.drawString(16, 130, "C1",
			(player.mo.kiryuinfo.heatactive and V_YELLOWMAP or 0)
			|V_HUDTRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER,
			"thin-center")
		end
	end
	local orb
	
	if (All7Emeralds(emeralds)) then
		orb = v.cachePatch("KYREDLIF")
	else
		orb = v.getSprite2Patch("kiryu", SPR2_XTRA, false, A)
	end
	
	v.drawScaled(16*FRACUNIT, 176*FRACUNIT, FRACUNIT/2, orb, V_HUDTRANS|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap("kiryu", player.mo.color))
end

//get queued midtexture heights
//unused
local function MidtextureClearQueue(v)
	while (midtextureQueue[1]) do
		local i = midtextureQueue[1]
		midtextureLibrary[i] = v.cachePatch(i).height
		table.remove(midtextureQueue, 1)
	end
end

local function KiryuHUD(v, player)

	if not (player.mo)
	or not (player.mo.skin == "kiryu")
	or G_IsSpecialStage() then
		return
	end

	HeatHUD(v, player)
	KiryuEnemyHP(v, player)
	//MidtextureClearQueue(v)
end

hud.add(KiryuHUD)


/*
⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠿⠿⠛⠛⠋⠉⠉⠉⠉⠉⠛⠛⠛⠿⠿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠿⠟⠋⠉⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠈⠉⠛⠿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡿⠛⠁⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠈⠻⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⣿⣿⡿⠋⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠻⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⣿⠿⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⢀⣀⣀⣤⣴⣿⣯⢿⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⡟⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠈⠉⠛⠛⠛⠻⠿⠿⠿⠿⢿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣻⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⡿⠁⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠉⠙⠛⠛⠿⠿⢿⣿⣿⣿⣿⣧⣻⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⠇⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⡀⠄⠄⠄⠄⡄⠄⠄⠄⠄⠉⠙⠛⠿⢧⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⢀⡄⠄⠄⠄⢀⣸⡇⠄⠄⠄⣼⣧⡀⠄⠄⠄⠄⠄⠄⠄⠄⠸⣿⣿⣿⣿
⣿⣿⣿⣿⣿⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⣰⣾⠇⠄⠄⢀⣾⣿⡇⠄⠄⢀⣿⣿⣿⡄⠄⠄⠄⠄⠄⠄⠄⠄⢻⣿⣿⣿
⣿⣿⣿⣿⡇⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⣀⡆⠄⢀⣼⣿⣿⠄⠄⣰⣿⣿⣿⡇⠄⠄⣼⣿⣿⣿⣷⠄⠄⠄⠄⠄⠄⠄⠄⢸⣿⣿⣿
⣿⣿⣿⣿⡇⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⠄⣰⣿⢁⣰⣿⣿⣿⡏⣠⣾⣿⣿⣿⣿⡇⠄⣾⣿⣿⣿⣿⣿⣷⠄⡀⠄⠄⠄⠄⠄⠄⣿⣿⣿
⣿⣿⣿⣿⡇⠄⠄⠄⠄⠄⠄⠄⠄⠄⢀⣾⣿⠿⠿⠿⠿⠿⠿⠷⠟⠿⢿⣿⣿⣿⡇⣸⣿⣿⣭⣽⣿⣿⣿⣾⣿⠄⠄⠄⠄⢰⡀⣿⣿⣿
⣿⣿⣿⡟⠄⠄⠄⠄⠄⠄⣀⠄⠄⠄⢸⣿⣿⣶⡆⠄⠄⠄⠄⠄⢰⣷⣿⣿⣿⣿⣿⣿⣿⡇⠄⠄⠄⠄⣶⣶⡿⠄⠄⠄⠄⢸⣇⢻⣿⣿
⣿⣿⣿⠃⠄⠄⠄⠄⢀⣾⣿⡃⠄⠄⢸⣿⣿⣿⡇⣤⡀⠄⠄⠄⢸⣿⣿⣿⣿⣿⣿⣿⣿⡇⠄⠄⠄⢰⣿⣿⠃⠄⠄⠄⠄⢸⣿⣿⣿⣿
⣿⣿⡟⠄⠄⠄⠄⠄⢸⣿⣿⣷⠄⠄⢸⣿⣿⡿⣷⣭⣥⣤⣤⣤⣾⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣦⣶⣼⣿⣿⠄⠄⠄⠄⠄⢸⣿⣿⣿⣿
⣿⡏⢀⣤⠄⠄⠄⠄⠄⢿⣿⣿⡀⠄⢸⣿⣿⡻⣾⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⡆⠄⠄⠄⠄⠈⢿⣿⣿⣿
⣯⣾⣿⣿⡇⠄⠄⠄⠄⠄⠙⠿⣧⠄⠈⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⠇⠄⠄⢰⣷⡀⠸⣿⣿⣿
⣿⣿⣿⣿⣿⡀⠄⠄⢠⡀⠄⠄⠄⠄⠄⢿⣿⣿⣿⣿⣿⣿⣿⣯⢹⣿⣿⣍⡉⠉⣽⣯⣿⣿⣿⣿⣿⣿⡿⠋⠄⠄⠄⣾⣿⣿⣦⣿⣿⣿
⣿⣿⣿⣿⣿⣷⡄⢀⣿⣿⡄⣤⠄⠄⠄⠄⠙⠻⣿⣿⣿⣿⣿⣿⣿⢿⣿⣿⣣⣾⣿⣿⣿⣿⣿⡿⠛⠁⠄⠄⠄⢀⣾⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⣿⣾⣿⣿⣷⣿⣷⣤⡀⣠⣠⣾⣦⣭⣟⢛⣿⣿⠿⠿⠶⠾⢿⣟⣛⡛⠉⢉⣤⣿⠄⢀⣴⣷⣀⣾⣿⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣽⣿⣿⣿⣿⣿⣷⣯⡽⠳⢷⡀⢠⣾⣿⣿⣧⣤⣾⣿⣿⣤⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⢿⣯⣾⣿⡿⣿⣿⣿⣿⣿⣿⣏⠄⠄⠄⢱⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿⣿
*/
