//you're a 24 hour cinderella now
freeslot(
"S_KIRYU_SING",
"S_KIRYU_SING_LEFT",
"S_KIRYU_SING_RIGHT",
"S_KIRYU_SING_DOWN",
"S_KIRYU_SING_UP",
"sfx_kysng1",
"sfx_kysng2",
"sfx_kysng3",
"sfx_kysng4"
)

sfxinfo[sfx_kysng1].caption = "Da"
sfxinfo[sfx_kysng2].caption = "Me"
sfxinfo[sfx_kysng3].caption = "Ne"
sfxinfo[sfx_kysng4].caption = "Yo"

states[S_KIRYU_SING] = {SPR_PLAY, SPR2_TAL1|FF_ANIMATE, -1, nil, 3, 5, S_PLAY_STND}
states[S_KIRYU_SING_LEFT] = {SPR_PLAY, SPR2_TAL2|FF_ANIMATE, 15, nil, 3, 5, S_KIRYU_SING}
states[S_KIRYU_SING_RIGHT] = {SPR_PLAY, SPR2_TAL3|FF_ANIMATE, 15, nil, 3, 5, S_KIRYU_SING}
states[S_KIRYU_SING_DOWN] = {SPR_PLAY, SPR2_TAL5|FF_ANIMATE, 15, nil, 3, 5, S_KIRYU_SING}
states[S_KIRYU_SING_UP] = {SPR_PLAY, SPR2_TAL4|FF_ANIMATE, 15, nil, 3, 5, S_KIRYU_SING}

local SQUISHTIME = 8

local function KiryuSing(player)
	if not (player.mo) then return end
	if not (player.mo.skin == "kiryu") then
		if player.mo.kiryuinfo.sing
			player.mo.state = S_PLAY_STND
			player.mo.kiryuinfo.sing = 0
		end
		return
	end
	
	
	if not (player.weapondelay)
	and (player.cmd.buttons & BT_TOSSFLAG) then
	
		if not (player.mo.kiryuinfo.sing)
			if not (player.mo.state == S_PLAY_STND)
			or (player.powers[pw_carry]) then
				return
			end
		end
		
		player.weapondelay = 10
		if (player.mo.kiryuinfo.sing) then
			player.mo.state = S_PLAY_STND
			player.mo.kiryuinfo.sing = 0
		else
			player.mo.state = S_KIRYU_SING
			player.mo.kiryuinfo.sing = 1
		end
	end
	
	
	if (player.mo.kiryuinfo.sing) and not (player.weapondelay)
		if (player.mo.state >= S_KIRYU_SING)
		and (player.mo.state <= S_KIRYU_SING_UP) then
		else
			player.mo.kiryuinfo.sing = 0
			return
		end
		
		if (player.mo.kiryuinfo.sing > 1)
		and ((player.cmd.forwardmove <= 20 and player.mo.kiryuinfo.sing == 2)
		or (player.cmd.forwardmove >= -20 and player.mo.kiryuinfo.sing == 3)
		or (player.cmd.sidemove <= 20 and player.mo.kiryuinfo.sing == 4)
		or (player.cmd.sidemove >= -20 and player.mo.kiryuinfo.sing == 5))
			player.mo.kiryuinfo.sing = 1
		end
		
		if (player.mo.kiryuinfo.sing <= 1) then
			local voiceInfo = {{S_KIRYU_SING_UP, sfx_kysng3}, {S_KIRYU_SING_DOWN, sfx_kysng4}, {S_KIRYU_SING_RIGHT, sfx_kysng1}, {S_KIRYU_SING_LEFT, sfx_kysng2}}
			local danceNum
			if (player.cmd.forwardmove > 20)
				danceNum = 1
				player.kiryusquish = -SQUISHTIME
			elseif (player.cmd.forwardmove < -20)
				danceNum = 2
				player.kiryusquish = SQUISHTIME
			elseif (player.cmd.sidemove > 20)
				danceNum = 3
				player.kiryusquish = SQUISHTIME
			elseif (player.cmd.sidemove < -20)
				danceNum = 4
				player.kiryusquish = SQUISHTIME
			end
			
			if (danceNum) then
				S_StopSound(player.mo)
				player.mo.frame = C
				player.mo.state = voiceInfo[danceNum][1]
				S_StartSound(player.mo, voiceInfo[danceNum][2])
				player.mo.kiryuinfo.sing = danceNum + 1
			elseif player.mo.state == S_KIRYU_SING and not (leveltime % 18)
				player.kiryusquish = SQUISHTIME
			end
		end
		
		player.cmd.forwardmove = 0
		player.cmd.sidemove = 0
	end
end

local function Thinker()
	for player in players.iterate do
		KiryuSing(player)
	end
end
addHook("PreThinkFrame", Thinker)